;**********************************************************************                                                            *
;    Filename:      KP6TD1  /           *
;    Date:  2018.11.04      2019.02.10   KP6TD1:2020.05.12 RB5(BAND SW) ɂSG@\ǉB                                                 *
;    File Version:                                          *
; ;	DDS AD9834pvO KP6 HF TRXp //KP6T1.asm(2018.05.06) QƈڐA 		                                                                  *
;    Author:   jk1xkp                                                     *
;    Company:                                                         *
;                                            
;      QlāF9850_128SG6.asm <SG5; LCD16x2Ή  //SG6;step=20kHzǉ &400k폜> 
;	gp
;	ohb		PIC16F819 iȊOɂp\j
;
;		NbN	NbN 8MHz
;**********************************************************************
;    Notes: 
;1.LCD 13ڂ Eƕ\Ƃ́APLL UnlockBVCObN͈͂H
;2.	EEPROM SAVE ADRESS
;		;#00h   #01h    #02h    #03h	#04h	#05h	#06h	#07h
;		;stROM, Freq0,	FReq1,	Freq2,	Nband- 5A		DSPadj	
;3.LCD\ʒu
; 0  7  .  0  5  0  .  0  k  1  _  R  +  1  .  3  
;@L  S  B  s  5  0  H  _  S  9            +
; L  5  _  M  S  R  B  _  S  9            + (MCR OS1 Diodeڑ)
;4.PIC16F819ĕtAdStep SW(PORTB.6)ȂAdB
;  EEPROM̏ݒ肪Ȃ
;5.dRIT SW(PORTB.7)ȂAdB
;  LCDg\[h(0-7)ݒ肪Ȃ
;7.sATCFidENX^ERgXguq̔z͏ȗj
;		( H:[qopen  L:[q2.4kGRDɗƂ)
;	ohbPUeWPX	
;	()̓sԍ
;	RA7-OSC1(16)		LCD RS	
;	RA6-OSC2(15)		LCD E	

;	RA5-MCL(04)		TX_PTT 		
;	RA4(03)			AD9834_SCK	
;	RA3(02)			74HC595B_SCK 
;	RA2(01)			AD9834_Fsy & HC595_PCK
;	RA1(18)			AD9834_Fselect	
;	RA0(17)			S meter Signal
;		LCD SC1602
;	RB7(13)			LCD DB4	=AD9834_DATA, 74HC595_Ser	    
;	RB6(12)			LCD DB5	
;	RB5(11)			LCD DB6	
;	RB4(10)			LCD DB7 (mode CW,LSB,USB)	
;	RB3(09)					  (mode CW,LSB,USB)
;	RB2(08)			o;TX on /Memory
;	RB1(07)			ENC-A	
;	RB0(06)			ENC-B	
;	GND	=R/~W,D
;				RB4`RB7́@L@xŃ^NgSWm
;umode (lsb,usb,cw)vuBandvustep(50,500Hz)vuRITvuPTTv

;**********************************************************************

	list      p=16f819           ; list directive to define processor
	#include <p16F819.inc>        ; processor specific variable definitions

	errorlevel  -302              ; suppress message 302 from list file

	__CONFIG   _CP_OFF & _WRT_ENABLE_OFF & _CPD_OFF & _CCP1_RB2 & _DEBUG_OFF & _LVP_OFF & _BODEN_OFF & _MCLR_OFF & _WDT_OFF & _PWRTE_ON &_INTRC_IO  

; '__CONFIG' directive is used to embed configuration word within .asm file.
; The lables following the directive are located in the respective .inc file.
; See data sheet for additional information on configuration word settings.

#define		PTT   	PORTA,5		;PTT		
#define		AD34CK 	PORTA,4		;AD9834_SCK
#define		H59_3  	PORTA,3		;3rd_74HC595P_SCK <Band select>
#define		RCK   	PORTA,2		;74HC595P_RCK
#define		FSY   	PORTA,2		;AD9834_Sync 

#define		Fselct	PORTA,1		;AD9834_Fselect
#define		RIT   	PORTA,0		;RIT VR50k
#define		RS   	PORTA,7		;LCD_RS
#define		E  		PORTA,6		;LCD_E

#define		DAT  	PORTB,7		;Data for AD9834 & 74HC595
#define		Memo  	PORTB,2		;Momory

;***** VARIABLE DEFINITIONS
VALUE		EQU	H'7A'
scn			EQU	H'7B'	;Bank0-4 
ADDR		EQU	H'7C'	;counter for Load/Save 
pc_temp		EQU	H'7D'
w_temp		EQU 0x7E        ; variable used for context saving 
status_temp EQU 0x7F        ; variable used for context saving
;   --------------- adress 20&H  
USB0		EQU	0x20	;20hԒn! LCD2sڑ1"USB"\f[^[
USB1		EQU	0x21	;21hԒn! LCD2sڑ2"USB"\f[^[
USB2		EQU	0x22	;22hԒn! LCD2sڑ3"USB"\f[^[
N			EQU	0x23	;
s_rit		EQU	0x24	;24hԒnBRIT+(2b )-( 2d)H 	
decrit0		EQU	0x25	;25hԒnBRIT̕΍(100HzP)10iϊBLCD\p
decrit1		EQU	0x26	;26hԒnBRIT̕΍(100HzP
decrit2		EQU	0x27	;27hԒn sgp
dot			EQU	0x28	;28hԒn.RIT\̐Ԃ̃hbg
Dstep0		EQU	0x29	; 50H or 10k or 1k	
Dstep1		EQU	0x2a	; 50H or 10k
Dstep2		EQU	0x2b	; 50H or 10k		;;	
stROM		EQU	0x2c	;must be 0x2c/ 
Freq0		EQU	0x2d	;AD9834 Freq0݁@(28-4jbit̂́@8bit
Freq1		EQU	0x2e	;AD9834 Freq0݁@(28-4jbit̂́@8bit											
Freq2		EQU	0x2f	;AD9834 Freq0݁@(28-4jbit̂́@8bit											
;   ------------- adress 30&H
Nband		EQU	0x30	;Nband(0-8) must be 0x30		;		
dec0		EQU	0x31	; 10ii[ꏊiPOoCgj
dec1		EQU 0x32    	
dec2		EQU	0x33		
dec3		EQU	0x34		
dec4		EQU	0x35	;10MHz
dec5		EQU	0x36	;1MHz
dec6		EQU	0x37	;100kHz
dec7		EQU	0x38	;10kHz
dec8		EQU	0x39	;1kHz
dec9		EQU	0x3A	;;0.1kHz
O_rit		EQU	0x3B	;;u+v;0<rit<128,, u-v;128rit<255  50HzP
ritSW		EQU	0x3C	;ritSW=1 or 0	
N_rit		EQU	0x3D	;new RIT	
wait_cn		EQU	0x3E		;
wait_cn2	EQU	0x3F		
;    ------------- adress 40&H
val0		EQU	0x40		; ϊliRQrbgj
val1		EQU	0x41
val2		EQU	0x42
val3		EQU	0x43
val_m		EQU	0x44; ꎞ]i[ꏊiTu[`Ŏgpj
y0			EQU	0x45	
y1			EQU	0x46
y2			EQU	0x47
y3			EQU	0x48
step0		EQU	0x49	;;ENCD̎gstep=8=H"8" (50Hz) or 1192=H"68d"(10kHz)
step1		EQU	0x4A	;;ENCD̎gstep	
het			EQU	0x4B	;/	up=1; lower=2
Csm			EQU	0x4C	;Smeter activeւ̃JE^[
ct			EQU	0x4D		;Sub counter
cp			EQU	0x4E	;wait_ routin ŎgĂJE^Bėpgp
cs			EQU	0x4F	;wait_ routin ŎgĂJE^Bėpgp
;    ------------- adress 50&H		
cn			EQU	0x50		;counter
DSPadj		EQU	0x51		;LCDg\@0-7 1=3.8ppm(0.38kHz/100MHz)̃}CiX\
old34		EQU	0x52	;;mode(LSB, USB,CW) 
new34		EQU	0x53	; mode(LSB, USB,CW) 
poi			EQU	0x54
x0			EQU	0x55	;
x1			EQU	0x56
x2			EQU	0x57
x3			EQU	0x58
x_m			EQU	0x59	; ꎞ]i[ꏊ(Tu[`Ŏgpj  	
if0			EQU	0x5a	;IFg  IF_tab load
if1			EQU	0x5b
if2			EQU	0x5c
d4			EQU	H'5d'
d8			EQU	H'5e'
reg01		EQU	H'5f'	;Encoder
;    ------------- adress 60&H	
NRb27		EQU	0x60	; ;RB߰Ă̌ݒl bit.7-2
ORb27		EQU	0x61	;ORB߰Ă̒l
old01		EQU	H'62'	; ;RB0,1߰Ẳߋl
new01		EQU	H'63'	; ;RB0,1߰Ă̌ݒl
RFreq0		EQU	H'64'  	;;Freq data RITTXdataێ
RFreq1		EQU	H'65'	;;Freq data RITTXdataێ 
RFreq2		EQU	H'66'  	;;Freq data RITTXdataێ
vfc			EQU	H'67'	;intrruptuɂ@vfc.0=1
CtbL		EQU	H'68'  	;AD9843ݎ́@f[^@16bit Upper8bit
CtbU		EQU	H'69'	; f[^@16bit Lower8bit
MsbL		EQU	H'6a'	;gf[^@MSB
MsbU		EQU	H'6b'	;gf[^@MSB
LsbL		EQU	H'6c'	;gf[^@LSB
LsbU		EQU	H'6d'	;gf[^@LSB
Reg_Freq	EQU	H'6e'	;if Reg_Freg=0, Freq0(ʏ), if Freg=1, Freq1,
Symb		EQU	H'6f'	;Smeter@l\'S' or M'P'ower
;    ------------- adress 70&H	
SN			EQU	H'70'	;; Smeter@l\@LCDQs10Ԗځ@@poi=25	
Dp1			EQU	H'71'	;;uff or _2dv;Smeter\1ځ@LCDQs11Ԗځ@@poi=26	
Dp2			EQU	H'72'	;;uff or _2dv;Smeter\2ځ@
Dp3			EQU	H'73'	;;uff or _2dv;Smeter\3
Dp4			EQU	H'74'	;;uff or _2dv;Smeter\4
Dp5			EQU	H'75'	;;uff or _2dv;Smeter\5
Dp6			EQU	H'76'	;;u+ab or _2dv;Smeter\6
Vs			EQU	H'77'	;;Smeter Signal
LCD3		EQU	H'78' 	;if LCD3=0,LCD3sڂ\. MCR(+)@OS2(-)DiodeڑLCD3=L=0
SG			EQU	H'79' 	;if SG=0,TRCV. if SG=1, SG@\@ON 
;**********************************************************************
	ORG     0x000           
  ; processor reset vector
	goto    start              ; go to beginning of program
	ORG     0x004             ; interrupt vector location
isr		;;荞ݏ-routine
i_rb0	movwf	w_temp		;W@File w_tempւ̕ۑ
		swapf	STATUS,0
		clrf	STATUS		;Bank0
		movwf	status_temp	;status@File@̕ۑ
	;	bcf		INTCON,GIE
isr0	;;荞ݏ-routine
		btfsc	ritSW,0	;if RIT=ON,goto pop1
		goto	pop1
		btfss	PTT	;if PTT=ON(L, on TX), then retfie
		goto	pop1
	;	call	readb		;input mode portb
isr1	movf	PORTB,0	
		andlw	B'00000011'	
		movwf	new01

	;	btfss	old01,0	;if old11.rb0=L, then goto pop
	;	goto	pop1

		call	wt255u	;255 usec҂.ݺނ̓,ݸޖh~		
		movf	PORTB,0		
		andlw	B'00000011'	;masking RB0-1
		subwf	new01,0
		btfss	STATUS,Z
		goto	isr1

		btfsc	new01,0	;if new11.rb0=H, then goto pop
		goto	pop1

		goto	encd
	
	;	btfsc	PORTB,0	;Rotary Ecd ;temp
	;	goto	pop1						;temp
encd	btfss	new01,1		;Rb1=HȂ vxo Z
		goto	issub		;vxo=vxo-step0
		;btfss	reg01,1			;Rb.1=LȂΌZ
		goto 	isadd		;vxo=vxo+step0

issub	call	sub_v		;vxo=vxo-step0
		goto	pop
isadd	call 	add_v		;vxo=vxo+step0
		goto	pop

pop		bsf		vfc,0		;vfo change record, vfc=1
pop1	swapf	status_temp,0	;status@File@̖߂
		movwf	STATUS	
		swapf	w_temp,1	;W@File@̖߂
		swapf	w_temp,0
		bcf		INTCON,1	;intcon-INTF(tOj̃Zbg
		bsf		INTCON,GIE 		; Enable INTs.
				
		retfie
;-----------
; remaining code goes here
;--------------------------------------------------------------

tab_dp	addwf	PCL,1  	;f[^7bit=1ƂBAhXf[^͂̂܂

		retlw	H'35'	;poi=0	dec[4]	;u1v //LCDaddress=H'80'
		retlw	H'36'	;poi=1	dec[5]	;u4v 
		retlw	H'ac'	 		;poi=2	u,vG2ch+80h	 
		retlw	H'37'	;poi=3	dec[6]	;u0v
		retlw	H'38'	;poi=4	dec[7]	;u5v
		retlw	H'39'	;poi=5	dec[8]	;u0v		
		retlw	H'ac'			;poi=6	u,v 
		retlw	H'3a'	;poi=7	dec[9]	;u1v
		retlw	H'eb'		;poi=8	ukv
		retlw	H'31'		;poi=9	u_v	;Nband /Dec0
		retlw	H'a0'		;poi=10	u_v
		retlw	H'd2'		;poi=11	uRv;52h+80h 
		retlw	H'24'		;poi=12	u+/-]	;s_rit;24hԒnBRIT+(2b )-( 2d)//LCDaddress=H'8C'
		retlw	H'25'		;poi=13	u1v		;decrit[0]	 
		retlw	H'28'		;poi=14	u.v		;dot	;28hԒn.RIT\̐Ԃ̃hbg
		retlw	H'26'		;poi=15	u2v		;decrit[1]

;   	ȉ2s
		retlw	H'20'		;poi=16	uU];20hԒnWX^ //LCDaddress=H'C0'
		retlw	H'21'		;poi=17 uSv
		retlw	H'22'		;poi=18	uBv	 
		retlw	H'f3'		;poi=19	usv;73h+80h
		retlw	H'29'		;poi=20	u5v
		retlw	H'2a'		;poi=21	u0v 	 
		retlw	H'2b'		;poi=22	uHv;
		retlw	H'a0'		;poi=23	u_v
		retlw	H'6f'		;poi=24	Svmb uS_v; or uPv 6fh+80h //LCDaddress=H'C8'
		retlw	H'70'		;poi=25	SN u6v;52h+80h
		retlw	H'71'		;poi=26	Dp1 uff or _2dv;S meter	
		retlw	H'72'		;poi=27	Dp2 uff or _2dv;
		retlw	H'73'		;poi=28 Dp3 uff or _2dv;
		retlw	H'74'		;poi=29	Dp4 uff or _2dv; 
		retlw	H'75'		;poi=30 Dp5  uff or _2dv
		retlw	H'76'		;poi=31 Dp6 u+ab or _2dv;

;   	ȉ3sڑO
		retlw	H'20'		;poi=32	uU];20hԒnWX^ //LCDaddress=H'C0'
		retlw	H'29'		;poi=33 u5v
		retlw	H'2a'		;poi=34	u0v	 
		retlw	H'cd'		;poi=35 uMv;4dh+80h //Memo
		retlw	H'd3'		;poi=36	uMv;53h+80h //Step
		retlw	H'd2'		;poi=37	uRv;52h+80h 	//RIT 
		retlw	H'c2'		;poi=38	uBv;42h+80h //Band
		retlw	H'a0'		;poi=39	u_v		

;======================
S_tabl 	addwf	PCL,1
	;	retlw	D'1'	;	;poi=0	0.0V  S0--
	;	retlw	D'6'	;Dp1	;poi=1	0.11V S3
	;	retlw	D'42'	;Dp2	;2oi=2	0.83V S5
	;	retlw	D'136'	;Dp3	;poi=3	2.65V S7
	;	retlw	D'168'	;Dp4	;poi=4	3.23V S8
	;	retlw	D'185'	;Dp5	;poi=5	3.62V  S9
	;	retlw	D'209'	;Dp6	;poi=6	4.09V  9+20dB
	;	retlw	D'212'	;Dp6		;poi=7	4.14V  9+40dB		
	;	retlw	D'212'	;Dp6	    ;poi=8	4.14V  9+60dB

		retlw	D'10'	;	;poi=0	0.0V  S0--
		retlw	D'20'	;Dp1	;poi=1	0.39V S3
		retlw	D'44'	;Dp2	;poi=2	0.86V S5
		retlw	D'90'	;Dp3	;poi=3	1.75V S7
		retlw	D'118'	;Dp4	;poi=4	2.3V S8
		retlw	D'145'	;Dp5	;poi=5	2.84V  S9
		retlw	D'196'	;Dp6	;poi=6	3.83V  9+20dB
		retlw	D'207'	;Dp6		;poi=7	4.05V  9+40dB		
		retlw	D'210'	;Dp6	    ;poi=8	4.11V  9+50dB

S_num 	addwf	PCL,1
		retlw	D'0'	;	;poi=0	0.0V  S0--
		retlw	D'3'	;	;poi=1	0.39V S3
		retlw	D'5'	;	;poi=2	0.86V S5
		retlw	D'6'	;	;poi=3	1.75V S7
		retlw	D'7'	;	;poi=4	2.3V S8
		retlw	D'8'	;	;poi=5	2.84V  S9
		retlw	D'9'	;	;poi=6	3.83V  9+20dB
		retlw	D'9'	;		;poi=7	4.05V  9+40dB		
		retlw	D'9'	;	    ;poi=8	4.11V  9+50dB	

S_desti	addwf	PCL,1
		goto	Stren0		;poi=0 ˁ@Signal strength 0
 		goto	Stren1		;poi=1 ˁ@Signal strength 3
		goto	Stren2		;poi=2 ˁ@Signal strength 5
		goto	Stren3		;poi=3 ˁ@Signal strength 7
		goto	Stren4		;poi=4 ˁ@Signal strength 8
 		goto	Stren5		;poi=5 ˁ@Signal strength 9
 		goto	Stren6		;poi=6 ˁ@Signal strength 9+20dB
 		goto	Stren6			;poi=7 ˁ@Signal strength 9+40dB
 		goto	Stren6			;poi=8 ˁ@Signal strength 9+50dB

Stren6	movlw	H'2B'		;Charau+v
		movwf	Dp6
Stren5	movlw	H'FF'		;Charau
		movwf	Dp5
Stren4	movlw	H'FF'		;Charauv
		movwf	Dp4
Stren3	movlw	H'FF'		;Charauv8
		movwf	Dp3
Stren2	movlw	H'FF'		;Charauv8
		movwf	Dp2
Stren1	movlw	H'FF'		;Charauv8
		movwf	Dp1
Stren0	return
;======================
B_data	addwf	PCL,1  	;		;W=Nbanmd// 0=< Nband@<=8
		goto	B_3.5	;Nband=0
		goto	B_7 	;Nband=1
		goto	B_10 	;Nband=2
		goto	B_14 	;Nband=3
		goto	B_18 	;Nband=4
		goto	B_21 	;Nband=5
		goto	B_24  	;Nband=6
		goto	B_28 	;Nband=7
		goto	B_50 	;Nband=8   ;܂Ł@H'0FF'255ȓ
	;-----------
 		  	;Nband=0	;3.5MHz;LO=15.550kHz
			;Freq=15.550/100 x 2^28 /(2^4)= 2608,857=H'27ced9'
B_3.5	movlw	H'd9'	; 	
		movwf	Freq0		
		movlw	H'ce'	;
		movwf	Freq1
		movlw	H'27'	;
		movwf	Freq2
		movlw	D'1'	;if D'1', then Up Hetro
		movwf	het
		return

		  	;Nband=1	;7MHz; LO=19.050kHz=H'30c49b'
B_7 	movlw	H'9b'	; 	
		movwf	Freq0		
		movlw	H'c4'	;
		movwf	Freq1
		movlw	H'30'	;
		movwf	Freq2
		movlw	D'1'	;if D'1', then Up Hetro
		movwf	het
		return

 		 	;Nband=2	;10.1MHz; LO=22.150kHz=H'38b439'
B_10	movlw	H'39'	; 	
		movwf	Freq0		
		movlw	H'b4'	;
		movwf	Freq1
		movlw	H'38'	;
		movwf	Freq2
		movlw	D'1'	;if D'1', then Up Hetro
		movwf	het
		return

 		  	;Nband=3	;14MHz; LO=26.050kHz=H'42b020'
B_14	movlw	H'20'	; 	
		movwf	Freq0		
		movlw	H'b0'	;
		movwf	Freq1
		movlw	H'42'	;
		movwf	Freq2
		movlw	D'1'	;if D'1', then Up Hetro
		movwf	het
		return

 		 	;Nband=4	;18.1MHz; LO=30.150kHz=H'4d2f1a'
B_18	movlw	H'1a'	; 	
		movwf	Freq0		
		movlw	H'2f'	;
		movwf	Freq1
		movlw	H'4d'	;
		movwf	Freq2
		movlw	D'1'	;if D'1', then Up Hetro
		movwf	het
		return

 		  	;Nband=5	;21MHz; LO=33.050kHz=H'549ba5'
B_21	movlw	H'a5'	; 	
		movwf	Freq0		
		movlw	H'9b'	;
		movwf	Freq1
		movlw	H'54'	;
		movwf	Freq2
		movlw	D'1'	;if D'1', then Up Hetro
		movwf	het
		return

 		 	;Nband=6	;24.93MHz; LO=36.936kHz=H'5e8e60'
B_24	movlw	H'60'	; 	
		movwf	Freq0		
		movlw	H'8e'	;
		movwf	Freq1
		movlw	H'5e'	;
		movwf	Freq2
		movlw	D'1'	;if D'1', then Up Hetro
		movwf	het
		return

 		 	;Nband=7	;28MHz;LO=40.050kHz=H'66872b'
B_28	movlw	H'2b'	; 	
		movwf	Freq0		
		movlw	H'87'	;
		movwf	Freq1
		movlw	H'66'	;
		movwf	Freq2
		movlw	D'1'	;if D'1', then Up Hetro
		movwf	het
		return

 	 	;Nband=8	;50MHz; LO=38.150kHz=H'61a9fb'
B_50	movlw	H'fb'	; 	
		movwf	Freq0		
		movlw	H'a9'	;
		movwf	Freq1
		movlw	H'61'	;
		movwf	Freq2
		movlw	D'2'	;if D'2', then Up Hetro
		movwf	het
		return
	;==============
IFset	btfss	new34,3 ;	;y@IF HzP x1/16 Ŏgdata
		goto	IFcw
		btfss	new34,4
		goto	IFusb
		goto	IFlsb

	  		;;IF Hz  ;100HzPʂŎgdata捞.
IFlsb	movlw	H'9a'		;IFusb=11,996.200Hz /100 =119,962 =H'1d49a'
		movwf	if0
		movlw	H'd4'
		movwf	if1
		movlw	H'1'
		movwf	if2 
;		clrf	y3
		return

	 		;;IF Hz ; 100HzPʂŎgdata捞
IFusb	movlw	H'b8'		;IFlsb=11,999.200Hz /100 =119,992 =H'1d4b8'
		movwf	if0
		movlw	H'd4'
		movwf	if1
		movlw	H'1'
		movwf	if2 
		;clrf	y3
		return

		;;IF Hz ; 100HzPʂŎgdata捞
IFcw	movlw	H'a2'		;IFcw=11,997.000Hz ˁ@119,970  =H'1d4a2'
		movwf	if0
		movlw	H'd4'
		movwf	if1
		movlw	H'1'
		movwf	if2 
		;clrf	y3
		return
;---------------------荞ݏuroutin------------
add_v					;18step					
		movf	step0,0				;add	Freq[0],step[0]
		addwf	Freq0,1
		movlw	1
		btfsc	STATUS,C
		addwf	Freq1,1
		btfsc	STATUS,C
		addwf	Freq2,1
		
		movf	step1,0				;add	Freq[1],step[1]
		addwf	Freq1,1
		movlw	1
		btfsc	STATUS,C
		addwf	Freq2,1
		return
		
sub_v				;18step
		movf	step0,0				;sub	Freq[0],step[0]
		subwf	Freq0,1
		movlw	1
		btfss	STATUS,C
		subwf	Freq1,1
		btfss	STATUS,C
		subwf	Freq2,1

		movf	step1,0				;sub	Freq[1],step[1];
		subwf	Freq1,1
		movlw	1
		btfss	STATUS,C
		subwf	Freq2,1
		return
;----------------
;------------------------------------------------------
start	
  ;-temp
		bsf  	STATUS,RP0	;oN1		
		movlw	B'01110100'	;OSC=8MHz
		movwf	OSCCON
		bcf  	STATUS,RP0	;oN0

		movlw	D'255'
		movwf	wait_cn
		call	wait_ms

		bsf  	STATUS,RP0	;oN1
		movlw	B'00111111'	;RBvAbv;;INTEDG=FallEdge
		movwf	OPTION_REG	

		movlw	B'01001110'	;pinset(AN4=D,AN3=D,AN2=D,AN1=D,AN0=Analog, Vref+=5V, Vref-=GND) 
		movwf	ADCON1	;Left Justified 

		movlw	B'00100001'	;ra1,2,3,4,6,7  inputoutput
		movwf	TRISA
		bcf  	STATUS,RP0	;oN0
		clrf	PORTA

		bsf  	STATUS,RP0	;oN1
		movlw	B'00001111'	;rb.0-rb.7sin  !rb,#11111111b	
		movwf	TRISB		;trisb
		bcf  	STATUS,RP0	;oN0
		clrf	PORTB
	
		bcf		RS		;LCD3 Check
		nop
		clrf	LCD3
		btfsc 	PTT		;PortA,5 ւDiodeڑ̗LCheck
		bsf		LCD3,0	;if LCD3=0,LCD3sڂ\
		bsf		RS

		call	writb
		call	init_lcd		; kbc

st1		call	load_dsp		;LCDg\ DSP_adj Load
		movlw	H'FF'
		subwf	DSPadj,0
		movlw  	H'0' 	
		btfss	STATUS,Z 	;if DSPadj=H'FF' ,then DSPadj=H'0'
		movf	DSPadj,0
		andlw	B'00000111'  	;8ȏ̏ʃ}XLO
		movwf	DSPadj

st2		clrf	SG
		call	readb
		btfsc	PORTB,7	;if RIT=L, then DSPadj
		goto	st3
		goto	FAdj9	;d LCDg\ 

st3		movlw	H'53'		;charauSvH'53'  or uPvH'50'
		movwf	Symb		
		movlw	H'39'		;charau0`9v
		movwf	SN
		movlw	H'2d'		;chara u-vH'2d' or uv H'FF'  
		movwf	Dp1	
		movwf	Dp2		
		movwf	Dp3
		movwf	Dp4
		movwf	Dp5
		movlw	H'2d'		;chara u-vH'2d' or u+v H'2b'  
		movwf	Dp6	

		movlw	H'30'
		movwf	dec0
		movwf	dec1
		movwf	dec2
		movwf	dec3
		movwf	dec4
		movwf	dec5
		movwf	dec6
		movwf	dec7
		movwf	dec8
		movwf	dec9
	
		movlw	B'00000011'
		movwf	old01	;
		movwf	new01	;
		bcf		Fselct 	;PortA.1
		clrf	Reg_Freq		;if Reg_Freg=0, Freq Regist0(ʏ), if Freg=1, Freq Regist1,
		
st4		movlw	B'00011000'
		movwf	old34
		movwf	new34

		movlw	B'11110000'
		movwf	ORb27
		movlw	B'11111100'
		movwf	NRb27

		movlw	D'1'
		movwf	het

		movlw	D'128'
		movwf	O_rit		;ʏrit=128.
		movwf	N_rit

		movf	Freq0,0
		movwf	RFreq0
		movf	Freq1,0
		movwf	RFreq1
		movf	Freq2,0
		movwf	RFreq2 
		movlw	B'00000001'
		movwf	ritSW
		call	ritChg	;setting ritSW=0

		movlw	H'8d'    ;;ENCD̏@step=8=H"8" (50Hz) or 1192=H"68d"(10kHz)
		movwf	step0
		movlw	H'6'
		movwf	step1
		call	stp_chg		;step 10  (50Hz)

		call	readb	;rb.2-7s input mode
		movlw	D'0'
		movwf	Nband
		call	Bnd_chg		;setting Nband=1

		call	writb
		call	AD98wake			;AD9834 wakeup//Power up
		call	AD98fin

start0		
		movlw	B'11111111'
		movwf	NRb27	;ENCD init set
		movlw	B'11110000'
		movwf	NRb27	;

		call	readb	;rb.2-7s input mode	;dZbg step-SW ON
st00	btfsc	PORTB,6	;if STEP=L, then reset
		goto	st05
st01	btfss	PORTB,6	;
		goto	st01
		goto	start1

st05	nop		;---------@SG@	-----2020.05.13------
		call	readb	;rb.2-7s input mode	;d SG BAND-SW ON
		btfsc	PORTB,5	;if BAND=H, skip to st06
		goto	st06
		movlw	D'0'	;d SGւ̕Flag	
		btfss	PORTB,5	;if BAND=L, then SG=1, SG@\@ON
		movlw	D'1'
		movwf	SG

		clrf	Nband
		call	Bnd_chg		;Nband 0  1(7MHz)//setting Freq0,Freq1, Freq2, het
		goto	start3

st06	call	load_1st
		movlw	B'00000001'
		subwf	stROM,0	 
		btfss	STATUS,Z	;if stROM=1, then st07 & Load_m else atart1
		goto	start1

st07	call	load_m		;EEPROM #0(mode) &01h-o5hԒnload
							;stROM, Freq0,	Freq1,	Freq2,	Nband- 5A
		movf	stROM,1	; if stROM=0, then init EEPROM save(sav_ini)
		btfss	STATUS,Z
		goto	start3

start1	movlw	B'00000001'	
		movwf	stROM ;stROM=1
		clrf	Nband
		call	Bnd_chg		;Nband 0  1(7MHz)//setting Freq0,Freq1, Freq2, het

		call 	sav_ini		; ̏EEPROMւ save
		goto	start35

start3 	nop		; ==Rev.1 2018.03.04==
		movlw	D'8'		;if Nband=8(50MHz), then het=D'2' else het=D'1' 
		subwf	Nband,0
		movlw	D'1'
		btfsc	STATUS,Z	; if Z=0, then het=D'2'
		movlw	D'2'	;if D'2', then Up Hetro
		movwf	het
		call	H595_Bset
		call 	setIF
		nop		; ==Rev.1 2018.03.04==

start35	call	writb
		call	AD98set	;
		call	putfre		;LCD1s=vfo +/- (ifv+ifdef)@kHzvZ
		call	put1st12
		call	put_rit4
		call	put2nd8

		btfsc	LCD3,0  ;if LCD3=0, then LCD3sڕ\
     	goto	start36

   	;	movlw	D'255'
	;	movwf	wait_cn
	;	call	wait_ms

		call	put3sht
start36	call	put2ndS7
		call	readb

start37	btfss	PORTB,5	;if BAND=H, then go on
		goto	start37

start4	call	writb
	
S_end	movlw	B'10010000'			;GIE=1 enable, INTE=1 enable
		movwf	INTCON
		bsf		INTCON,7	;荞݊Jn 

main	bcf		vfc,0
		movlw	H'FF'
  		movwf	Csm

main1	call	writb	;Rb.4-7 o̓|[g
		call	AD98set			;AD9834 set
	
	;	bcf		INTCON,7	;荞݋֎~ 
		call	putfre		;LCD1s=vfo +/- (ifv+ifdef)@kHzvZ
	;	bcf		INTCON,7	;荞݋֎~

main12	call	put1st12
		call	put2ndS7 

		btfsc	LCD3,0  ;if LCD3=0, then LCD3sڕ\
     	goto	main15
 		call	put3sht
		goto	main15
main14	call	put2nd8	   
main15	call	put_rit4	;1sځ@10Ԗڈȍ~@RIT֌W

main3	btfsc	PTT	;if RA.5=L, then TX 
		goto	main32
		goto	main33

main32	call	RX	
		goto	main4

main33	call	TX	;RXTX 		
main34	call	chk34		; TX́@PORTB.3 & 4 check

		decfsz	Csm,1
		goto	main36
		bcf		vfc,0
		call	Smeter	;Power Meter/TX	
main36	nop
		btfss	PTT	;if RA.5=L, then TX continue
		goto	main34
		call	RX	;;TXRX
	;----------RIT---------
main4	btfss	ritSW,0	;if RIT=Off,goto main5	//ritSW=1 or 0
		goto	main5
		goto 	Rmain1		;if RIT=On ,goto Rmain1(RIT)
	
Rmain1	;RIT
		bcf		INTCON,7	;荞݋֎~
		bcf		vfc,0	
		call	Smeter	;S Meter durin RIT		
Rm0		call	rit_ck	;rit EncorderωAcall, RXLCD1sڕ\
Rm5		call	chk27		;RB2-7 ̓`FbN
		call	chk34
		goto	main3
	;-----------RIT end-----
main5	call	readb		;input mode portb
		;	bsf		INTCON,7	;荞݊Jn
main51	decfsz	Csm,1
		goto	main52
		call	Smeter	;S Meter
		movlw	H'FF'
  		movwf	Csm
main52	call	wt5u		;5 usec҂		
		btfsc	vfc,0	;
		goto	main	;
main53	call	chk34	;;RB3-4 ̓`FbN
		call	chk27		;RB2-7 ̓`FbN

	;***added for RIT
		btfsc	ritSW,0	;if RIT=ON,goto main15	//ritSW=1 or 0
		goto	main15
		goto 	main7
	;***added for RIT
main7	btfss	vfc,0	;
		goto	main51	;
		goto	main
;----------------------------
;-------------------------------
chk34	btfsc	SG,0	;if SG=1, return
		return

		call	readb		;input mode portb	
		movf	PORTB,0		
		andlw	B'00011000'	;Rb3,4,̂ݎc
		movwf	new34	
		subwf	old34,0
		btfss	STATUS,Z	;if new34=old34, then return
		goto	setIF	;LSB,USB,CW check
		return

chk27	call	readb		;input mode portb	
		movf	PORTB,0		
		andlw	B'11111100'	;Rb2,3,4,5,6,7̂ݎc
		btfss	PTT	;if PTT=ON(L, on TX), then PORTB.5 & 6 =H mask
		return
		goto	chk50
	;	iorlw	B'01100000'		
chk50	movwf	NRb27
		movf	NRb27,0
		subwf	ORb27,0
		btfss	STATUS,Z		;if Nrb27=ORb27, then return
		goto	c27set	
		return
	
c27set	bcf		INTCON,7	;荞݋֎~
		movf	NRb27,0		;mov	old47,new47
		movwf	ORb27
	
ch4		btfss	NRb27,5		;if Rb.5=L, then Band_change
		goto	Bnd_chg
			
ch5		btfss	NRb27,6		;if Rb.6=L, then Step_change
		goto	stp_chg

ch1		btfsc	SG,0	;if SG=1, goto ch27e
		goto	ch27e
		btfss	NRb27,2		;if Rb.2=L, then Memo
		goto	Memory

ch6		btfsc	SG,0	;if SG=1, goto ch27e
		goto	ch27e
		btfss	NRb27,7		;if Rb.7=L, then RIT set
		goto	ritChg

ch27e	bsf		INTCON,7	;荞݊Jn
		movlw	D'10'
		movwf	wait_cn
		call	wait_ms
		return
;-----------------------------
TX		;call	writb
	;	btfss	ritSW,0		; if RIT is Off, then return
	;	return
		bsf		Fselct		;Freq1  PORTA,1	
		return

RX		bcf		Fselct		;Freq0  PORTA,1	
		return	
;--------------------------------
;----------------------------------
ritChg	movf	ritSW,0	;ritSW	=1 or 0	
		btfss	STATUS,Z
		goto	r_off
		goto	r_on	
	
r_on	bcf		INTCON,7	;荞݋֎~
		movf	Freq0,0
		movwf	RFreq0
		movf	Freq1,0
		movwf	RFreq1
		movf	Freq2,0
		movwf	RFreq2 
		clrf	step0
		clrf	step1
		movlw	D'128'
		movwf	x0

		call	writb
		call	AD98TX  ;AD9834 Freq1 set for RX RIT
		bcf		Fselct		;Freq0  PORTA,1	
		bsf		ritSW,0
		;s_rit		;24hԒnBRIT+(2b )-( 2d)H 
		;decrit0	;25hԒnBRIT̕΍(100HzP)10iϊBLCD\p
		;decrit1	;26hԒnBRIT̕΍(100HzP
		;decrit2	;26hԒnBRIT̕΍(100HzP
		;dot		;27hԒn.RIT\̐Ԃ̃hbg"."
		movlw	H'30';chara "0"
		movwf	decrit0	;Chara "0"
		movwf	decrit1	;Chara "0"
		movlw	H'2E'	;Chara "."
		movwf	dot

rit_ck	call	wt255u	;255 usec҂.
		call	Adjrit	;Encorder荞
		movf	N_rit,0 ;new RIT
		subwf	O_rit,0 ;old RIT
		btfsc	STATUS,Z
		return			;if N_rit=O_rit, return
		goto	rit_c1

rit_c1	movf	N_rit,0
		movwf	x0
		movlw	D'128'
		subwf	x0,0		;W=x0 +(256-128)

		btfsc	STATUS,C	;W=x0 +(256-128); if rit<128, then "-"
		goto	R_plus
		goto	R_minus	

R_plus	movlw	H'2b'	;RIT"+"(2bh)
		movwf	s_rit
		movlw	D'128'
		subwf	x0,0 	;W= x0+(256-128)
		movwf	x0		;x0= x0-128
		movwf	step0
		clrf	step1
		call 	stepx8  ;step=step x8 //DDS dataϊ

		call	add_r	;FreqRFreg &// RFreq=RFreq + step(rit)
		goto	r_div

R_minus	movlw	H'2d'	;RIT"-"(2dh)
		movwf	s_rit
		movf	x0,0
		sublw	D'128' ;W=128+ (256-W)	
		movwf	x0		;x0= 128-x0
		movwf	step0
		clrf	step1
		call	stepx8	;step=step x8 //DDS dataϊ

		call	sub_r
		goto	r_div

r_div	call	writb	;Rb.4-7 o̓|[g
		call	AD98RX  ;AD9834 set for RX RIT

		movf	x0,0	
		movwf	val0
		sublw	D'1' 	;W=1+ (256-W)
		btfsc	STATUS,Z
		goto	r_div3
r_div2	bcf		STATUS,C	;val0= Val0x 1/2
		rrf		val0,1		

r_div3	call 	dc_rit	;16i@10i
		movf	N_rit,0
		movwf	O_rit	;N_rit,O_rit
		goto	rend
	;----
r_off	movf	RFreq0,0
		movwf	Freq0
		movf	RFreq1,0
		movwf	Freq1
		movf	RFreq2,0
		movwf	Freq2

		bcf		Fselct		;Freq0  PORTA,1	

		call	writb
		call	AD98set  ;AD9834 set for none RIT
		bcf		ritSW,0	;ritSW=0 
		bsf		INTCON,7	;荞݊Jn

		movlw	H'20'	;Chara "_"
		movwf	s_rit
		movlw	H'4F'	;Chara "O"
		movwf	decrit0
		movlw	H'46'	;Chara "F"
		movwf	dot
		movlw	H'46'	;Chara "F"
		movwf	decrit1
		movlw	H'20'	;Chara "_"
		movwf	decrit2

		; step=50Hz
		movlw	H'8'  ;step=8=H"8" (50Hz)
		movwf	step0
		clrf	step1		

		movlw	H'35'	; steplƂ50H(35h, 30h, 48h)/Chara "5"
		movwf	Dstep0
		movlw	H'30'	;Chara "0"
		movwf	Dstep1
		movlw	H'48'	;Chara "H"
		movwf	Dstep2
		;;
		movlw	D'128'	; RIT=128
		movwf	O_rit		;ʏrit=128.
		movwf	N_rit
		goto	rend
	;----	
rend	call	put_rit4		;RITύX\
		btfsc	ritSW,0	;if ritSW=1, then return
		return 

		bsf		INTCON,7	;荞݊Jn
		goto	ch27e
	;	;return				
;-------------------
stepx8	bcf		STATUS,C	;step= 2x N_rit
		rlf		step0,1
		rlf		step1,1
		bcf		STATUS,C	;step= 4x N_rit
		rlf		step0,1
		rlf		step1,1
		bcf		STATUS,C	;step= 8x N_rit
		rlf		step0,1
		rlf		step1,1

		movf	RFreq0,0
		movwf	Freq0
		movf	RFreq1,0
		movwf	Freq1
		movf	RFreq2,0
		movwf	Freq2
		return
;------------------
add_r	;Freq=Freq + step(rit)
		movf	step0,0				;add	Freq[0],step[0]
		addwf	Freq0,1
		movlw	1
		btfsc	STATUS,C
		addwf	Freq1,1
		btfsc	STATUS,C
		addwf	Freq2,1
		
		movf	step1,0				;add	Freq[1],step[1]
		addwf	Freq1,1
		movlw	1
		btfsc	STATUS,C
		addwf	Freq2,1
		return
		
sub_r	movf	step0,0				;sub	Freq[0],step[0]
		subwf	Freq0,1
		movlw	1
		btfss	STATUS,C
		subwf	Freq1,1
		btfss	STATUS,C
		subwf	Freq2,1

		movf	step1,0				;sub	Freq[1],step[1];
		subwf	Freq1,1
		movlw	1
		btfss	STATUS,C
		subwf	Freq2,1
		return

;-------------
;----------------------------
Adjrit	
Adj1	call	readb		;input mode portb
Adj2	movf	PORTB,0	
		andlw	B'00000011'	
		movwf	new01

Adj5	btfss	old01,0		;if old01.0= HL,then next step, else goto Adj2(Adj_e)
		goto 	Adj_e
		btfsc	new01,0
		goto 	Adj_e
		goto	encd1

encd1	btfss	new01,1	;Rb1=LȂ N_rit Zadd
		goto	Adj_dec	;Sub	N_rit=N_rit-1
		goto	Adj_add	;Add	N_rit=N_rit+1

Adj_dec	decf	N_rit,1	
		movf	N_rit,0
		movlw	H'1'
		btfsc 	STATUS,Z 	;if N_rit=0(Z=1), rhen N_rit=1
		movwf	N_rit
		goto	Adj_e

Adj_add	incf	N_rit,1
		movf	N_rit,0
		movlw	H'FF'
		btfsc 	STATUS,Z 	;if N_rit=0(Z=1), rhen N_rit=FF(256)
		movwf	N_rit
		goto	Adj_e

Adj_e	movf	new01,0		;old01=new01
		movwf	old01
		return

;----------------------

;--------------------------------
stp_chg		;    ENCD́@step=8=H"8" (50Hz)  or 168=H'A7'(1kHz) or 1677=H"68d"(10kHz)
		btfsc	ritSW,0		;Masking during RIT
		goto	ch27e

		movf	step0,0
		sublw	H'8d'  ;A8 as H"68d"(10kHz)
		btfsc	STATUS,Z
		goto	st50

		movf	step0,0
		sublw	H'A7'  ;A7 as H"A7"(1kHz)
		btfss	STATUS,Z		
		goto	st1k
		goto	st10k

st50	movlw	H'8'  ;step=8=H"8" (50Hz)
		movwf	step0
		clrf	step1		

		movlw	H'35'	; steplƂ50H(35h, 30h, 48h)/Chara "5"
		movwf	Dstep0
		movlw	H'30'	;Chara "0"
		movwf	Dstep1
		movlw	H'48'	;Chara "H"
		movwf	Dstep2
		goto	stend

st1k	movlw	H'A7'  ;168=H'A7'(1kHz)
		movwf	step0
		movlw	H'0'
		movwf	step1

		movlw	H'30'	; steplƂ _Chara "0"
		movwf	Dstep0
		movlw	H'31'	;Chara "1"
		movwf	Dstep1
		movlw	H'6B'	;Chara "k"
		movwf	Dstep2
		goto	stend	

st10k	movlw	H'8d'   ;1192=H"68d"(10kHz)
		movwf	step0
		movlw	H'6'
		movwf	step1

		movlw	H'31'	; steplƂ10k(31h, 30h, 6Bh)/Chara "1"
		movwf	Dstep0
		movlw	H'30'	;Chara "0"
		movwf	Dstep1
		movlw	H'6B'	;Chara "k"
		movwf	Dstep2
		goto	stend	
stend	call	put2nd8		;stepύX\
		btfsc	LCD3,0  ;if LCD3=0, then LCD3sڕ\
     	goto	ch27e

  		movlw	D'255'
		movwf	wait_cn
		call	wait_ms

  		movlw	D'255'
		movwf	wait_cn
		call	wait_ms

		call	put3sht
		goto	ch27e
	;	;return
;----------------------------
Bnd_chg		;3.5, 7, 10,14,18,21,24.5,28,50MHz		
			; 0 , 1 , 2, 3, 4, 5,   6, 7, 8 =Nband
		btfsc	ritSW,0		;Masking during RIT
		goto	ch27e

		incf	Nband,1	;Nband= Nband+1 (0<= Nband <=8)
		movf	Nband,0
		sublw	D'9'
		movlw	D'0'	
		btfss	STATUS,Z
		movf	Nband,0
		movwf	Nband
		goto	setBand	;setting Freq0, Freq1, Freq2, het
		;return
;----------------------------
setBand	;NbandĂ	;set nr0,nr1 & het
		; "B_data" callƂɁAW=Nband Ƃ邱ƁB@0=< Nband@<=8
		movf	Nband,0
		andlw	B'00001111'
		call	B_data ;;setting Freq0, Freq1, Freq2 & het
		btfss	SG,0	;if SG=0, then goto stB5 (normal TRCV)
		goto	stB5 
	;--------- SG ---------
		movf	Freq2,0	
		movwf	x2
		movf	Freq1,0
		movwf	x1
		movf	Freq0,0
		movwf	x0

		movlw	H'1E'	;IF=11.997kHz. Then ;Freq=11.997/100 x 2^28 /(2^4)= 2012,762=H'1Eb65A' 	
		movwf	y2
		movlw	H'b6'
		movwf	y1
		movlw	H'5A'
		movwf	y0

		btfsc	het,0		;D'1'	;if D'1', then Up Hetro
		goto	stB1
		call	add_xy	;	(24bit)(24bit){y(24bit)
		goto	stB2
		
stB1	call	sub_xy	; (24bit)(24bit)-y(24bit)
stB2	movf	x2,0
		movwf	Freq2
		movf	x1,0
		movwf	Freq1
		movf	x0,0
		movwf	Freq0
	;---------- TRCV -------
stB5	call	writb
		call	H595_Bset
		call	AD98set

		goto	setIF
	;	;return
;--------------------------------------------------------
;-------------------------------------------------------	
setIF	movf	new34,0		;mov	old47,new47
		movwf	old34

		nop		;RB3, 4H/LɂACW,USB,LSB IFZbg @y
		call	IFset	;;if0-if2ց@IF Hz x1/16 PʂŎgdata 

Dmode 	btfsc	SG,0
		goto	D_SG

		btfss	new34,3
		goto	Dcw
		btfss	het,0		;;/	up=1; lower=2
		goto	Dh_2
		goto	Dh_1
		nop
Dh_1	btfss	new34,4	;Normal
		goto	Dusb
		goto	Dlsb

Dh_2	btfsc	new34,4	;Reveasal
		goto	Dusb
		goto	Dlsb

Dcw		movlw	H'43'	;Chara "C"
		movwf	USB0
		movlw	H'57'	;Chara "W"
		movwf	USB1
		movlw	H'20'	;Chara "_"
		movwf	USB2
		goto	D_end

Dlsb	movlw	H'4C'	;Chara "L"
		movwf	USB0
		movlw	H'53'	;Chara "S"
		movwf	USB1
		movlw	H'42'	;Chara "B"
		movwf	USB2
		goto	D_end

Dusb	movlw	H'55'	;Chara "U"
		movwf	USB0
		movlw	H'53'	;Chara "S"
		movwf	USB1
		movlw	H'42'	;Chara "B"
		movwf	USB2
		goto	D_end

D_SG	movlw	H'53'	;Chara "S"
		movwf	USB0
		movlw	H'47'	;Chara "G"
		movwf	USB1
		movlw	H'20'	;Chara "_"
		movwf	USB2
		goto	D_end

D_end	call	RX
	;	call	writb
		call	putfre		;LCD1s=vfo +/- (ifv+ifdef)@kHzvZ

		call	put1st12
		call	put_rit4
		call	put2nd8

		btfsc	LCD3,0  ;if LCD3=0, then LCD3sڕ\
     	goto	ch27e

  	;	movlw	D'255'
	;	movwf	wait_cn
	;	call	wait_ms

  		movlw	D'255'
		movwf	wait_cn
		call	wait_ms

		call	put3sht
 		goto	ch27e
	;	;return
;------------------
;========S meter===== 
Smeter	btfsc	vfc,0	;S meter	;A/DϊJn@@AN0|[g@AiO
		return	
adloop	movlw	B'01000001'	;set AD_channel=AN0, conversion_clock=16Tosc, )  
		movwf	ADCON0

		movlw	D'25'		;acquisition time wait 25usec
		movwf 	wait_cn	
		call	wait_us 

		bsf  	ADCON0,GO
ad_pol		
		nop  
		btfsc	ADCON0,GO
		goto	ad_pol		;AD conv polling
		movf	ADRESH,0
		movwf	Vs		;ADϊLeft Justified@Vs荞݁@(0-255)
		bcf  	ADCON0,0	;AD OFF
		bcf  	ADCON0,GO	;AD conv reset

		btfsc	vfc,0	;S meter	;A/DϊJn@@AN0|[g@AiO
		return
		;return
	;-----------
LCD_sm	movlw	H'53'		;charauSvH'53'  
		btfss	PTT
		movlw	H'50'		;charauPvH'50'  
		movwf	Symb
		
		movlw	H'2d'		;chara u-vH'2d' or uv H'FF'  
		movwf	Dp1	
		movwf	Dp2		
		movwf	Dp3
		movwf	Dp4
		movwf	Dp5
		movlw	H'20'		;chara u-vH'20' or u+v H'2b'  
		movwf	Dp6	

		movlw	D'8'
		movwf	cn
		clrf	poi
Lsm1	movf	poi,0
		call	S_tabl
		subwf	Vs,0	;W=Vs+ (256-S_t)
		btfss	STATUS,C ;if Vs> S_t, C=1 then goto out
		goto	Lsm_out
		btfsc	STATUS,Z ;if Vs= S_t, Z=1 then goto out
		goto	Lsm_out
		nop
		incf	poi,1
		decfsz	cn,1
		goto	Lsm1

Lsm_out	movf	poi,0	;W=poi 
		movwf	ct
		sublw	D'8'		;W=8 +(256-ct)	;Max. ct<=8
		movlw 	D'8'	
		btfsc	STATUS,C	;Max. ct<=8
		movf	ct,0
		call	S_desti  	;S1`S5 set
		
		movf	ct,0
		call 	S_num		
		xorlw	B'00110000'	;;set upper bit=3 for LCD display
		movwf	SN
		nop
		btfsc	vfc,0	;S meter	;A/DϊJn@@AN0|[g@AiO
		return	
LCD_e	call	put2ndS7

		movlw	H'FF'		;Smeter interval counter 
  		movwf	Csm
		return	

;-----------------
H595_Bset	;H595(3rd)Band sel SW̐ݒ
		movlw	B'00000001'
		movwf	d8
		bcf		STATUS,C
		movf	Nband,0
		btfsc	STATUS,Z
		goto	H595_B3

		movf	Nband,0
		movwf	cn
H595_B1	bcf		STATUS,C
		rlf		d8,1
		decfsz	cn,1		;djnz	cn,H595_B1
		goto	H595_B1	

H595_B3	movlw	D'8' 	;cn,#8
		movwf	cn
HC595C	call	writb
		rlf  	d8,1
		btfss	STATUS,C
		bcf		DAT
		btfsc	STATUS,C
		bsf		DAT		

		bcf		H59_3		;SCK
		bsf		H59_3		;SCK
		decfsz	cn,1		;djnz	cn,HC595C
		goto	HC595C
		bcf		RCK	
		bsf		RCK		;register to output latch

		movlw	D'8'		;if Nband=8, then SCK=H else SCK=L 
		subwf	Nband,0
		btfss	STATUS,Z
		bcf		H59_3		;SCK
		nop
		return

;------------------------------		
putfre	; 5000step/    het	;; upper=1; lower=2
			;Upper Hetero  f(Hz x1/16 P)=Freq0 - IF 
			;Lower Hetero  f(Hz x1/1 6P)=Freq0 + IF
					;	ȉ IF=<(62,825.0kHz+IF)> or <(62,825.0kHz-IF)>
	;--+++
		movf	Freq0,0
		movwf	x0
		movwf	y0
		movf	Freq1,0
		movwf	x1
		movwf	y1
		movf	Freq2,0
		movwf	x2		
  		movwf	y2
cal_1	call	yr_2	;y= 1/2 x Fre;(1/2^1)
		call	add_xy	; (24bit)(24bit){y(24bit)@

cal_2	call	yr_2	;y= 1/2 xFre;(1/2^2)
		call	add_xy	; (24bit)(242bit){y(24bit)@

cal_3	call	yr_2	;y= 1/2 xFre;(1/2^3)
		call	add_xy	; (24bit)(24bit){y(24bit)@

cal_5	call	yr_4	;y= 1/2 xFre;(1/2^5)
		call	add_xy	; (24bit)(24bit){y(24bit)@

cal_10	call	yr_32	;y= 1/2 xVFO;(1/2^10)
		call	add_xy	; (24bit)(24bit){y(24bit)@

cal_13	call	yr_8	;y= 1/2 xVFO;(1/2^13)	;1.22kHz/7MHz (6.4kHz/MCLK 100MHz)
		call	add_xy	; (24bit)(24bit){y(24bit)@

cal_15	call	yr_4	;y= 1/2 xVFO;(1/2^15)	;0.3kHz/7MHz (1.6kHz/MCLK 100MHz)
		btfss	DSPadj,2
		goto	cal_16
		call	sub_xy	; (24bit)(24bit)-y(24bit)

cal_16	call	yr_2	;y= 1/2 xVFO;(1/2^16)	;0.15kHz/7MHz (0.8kHz/MCLK 100MHz)
		btfss	DSPadj,1
		goto	cal_17
		call	sub_xy	; (24bit)(24bit)-y(24bit)

cal_17	call	yr_2	;y= 1/2 xVFO;(1/2^17)	;0.08kHz/7MHz (0.4kHz/MCLK 100MHz)
		btfss	DSPadj,0
		goto	cal_e
		call	sub_xy	; (24bit)(24bit)-y(24bit)

cal_e	nop	; x, ɌvZʁ@Fre=iFreq0 -/+ IFj@Ă
		movf	x0,0	;x= x/ (2^8)
		movwf	x_m
		movf	x1,0	;
		movwf	x0
		movf	x2,0	;
		movwf	x1		
		clrf	x2

		bcf		STATUS,C	;x= x/ (2^7)
		rlf		x_m,1
		rlf		x0,1
		rlf		x1,1
		rlf		x2,1

		bcf		STATUS,C	;x= x/ (2^6)
		rlf		x_m,1
		rlf		x0,1
		rlf		x1,1
		rlf		x2,1

		bcf		STATUS,C	;x= x/ (2^5) x 
		rlf		x_m,1
		rlf		x0,1
		rlf		x1,1
		rlf		x2,1
		nop 		 ; Then x=X/ 2^5 x (1,000,000/2^9)
	;--+++
		btfsc	SG,0	;if SG=1, then SG
		goto	calfre
	;--+++		
		movf	if0,0
		movwf	y0
		movf	if1,0
		movwf	y1	
		movf	if2,0
		movwf	y2

		btfss	het,0  ;if Het=B'0000 0001' ,then upper
		goto 	lower
 		goto  	upp 

upp		call	sub_xy	;(24bit)(24bit)-y(24bit)@//
		goto  	calfre

lower	call	add_xy	;(24bit)(24bit)+ y(24bit)/
	
calfre	movf	x0,0	
		movwf	val0
		movf	x1,0	
		movwf	val1
		movf	x2,0	
		movwf	val2		

		call	dcmain		;16i-10iϊ	/4900step	
		return
;------------

;;------------------------------------------------------------
;------------
yr_64	bcf		STATUS,C
		rrf		y2,1
		rrf		y1,1
		rrf		y0,1
yr_32	bcf		STATUS,C
		rrf		y2,1
		rrf		y1,1
		rrf		y0,1
yr_16	bcf		STATUS,C
		rrf		y2,1
		rrf		y1,1
		rrf		y0,1
yr_8	bcf		STATUS,C
		rrf		y2,1
		rrf		y1,1
		rrf		y0,1
yr_4	bcf		STATUS,C
		rrf		y2,1
		rrf		y1,1
		rrf		y0,1
yr_2	bcf		STATUS,C
		rrf		y2,1
		rrf		y1,1
		rrf		y0,1
		return
		;----------------
;--------------------
put1st12		; 590step+680us
		call	writb				;/8step
		clrf	poi	;tab_dp(LCD)1Ԗڕ\ poi=0
		movlw	H'80'
		movwf	d4
		bcf		RS		;cursorʒu 
		call	write_lcd4			;/20step+40us
		movlw	D'12'			;mov	cn,#12	;12
		movwf	cn
		goto	dp_bun

put_rit4		; 580step+680us
		call	writb				;/8step
		movlw	D'12'	;tab_dp(LCD)13Ԗpoi=12
		movwf	poi
		movlw	H'8C'	;cursol 1s13 	u+v
		movwf	d4
		bcf		RS		;cursorʒu 
		movlw	D'4'			;mov	cn,#4	;4
		movwf	cn
		call	write_lcd4			;/20step+40us
		goto	dp_bun

put2nd8		; 580step+680us//2sځ@ŏ8
		call	writb				;/8step
		movlw	D'16'	;tab_dp(LCD)17Ԗ=LCD2s1\poi=16
		movwf	poi
		movlw	H'c0'	;cursol 2s
		movwf	d4
		bcf		RS		;cursorʒu 
		call	write_lcd4			;/20step+40us
		movlw	D'8'			;mov	cn,#8	;8
		movwf	cn
		goto	dp_bun

put3sht	btfsc	LCD3,0  ;if LCD3=0, then LCD3sڕ\
     	return
		call	writb				;/8step
		movlw	D'32'	;tab_dp(LCD)32Ԗ=LCD3s9\poi=24
		movwf	poi
		movlw	H'C0'	;cursol 2s
		movwf	d4
		bcf		RS		;cursorʒu 
		call	write_lcd4			;/20step+40us
		movlw	D'8'			;mov	cn,#8	;8
		movwf	cn
		goto	dp_bun

put2ndS7	; 580step+680us//2sځ@i8
		call	writb				;/8step
		movlw	D'24'	;tab_dp(LCD)26Ԗ=LCD2s9\poi=24
		movwf	poi
		movlw	H'C8'	;cursol 2s
		movwf	d4
		bcf		RS		;cursorʒu 
		call	write_lcd4			;/20step+40us
		movlw	D'8'			;mov	cn,#8	;8
		movwf	cn

		btfsc	vfc,0	;S meter	;A/DϊJn@@AN0|[g@AiO
		return

		goto	Sdp_bun
Sdp_bun		;\				;/16x(35step+40us)=560step+640us
		bsf		RS
Sdpb1	movf	poi,0
		call	tab_dp
Sdpb3	movwf	FSR		;WX^[AhX
		movf	INDF,0
		movwf	d4

		btfsc	vfc,0	;S meter	;A/DϊJn@@AN0|[g@AiO
		return

Sdpb5	call	write_lcd4	;
		incf	poi,1
		decfsz	cn,1
		goto	Sdpb1
		return

;-------;\郋[`	;\X^ĆAtab_dpɑΉ	;poi=ʒuA0<=poi<tab_dpmaxl
dp_bun		;\				;/16x(35step+40us)=560step+640us
		bsf		RS
dpb1	movf	poi,0
		call	tab_dp
		movwf	d4
		btfsc	d4,7		;if d4.7=1, then dpb4
		goto	dpb4
		;goto	dpb3
dpb3	movwf	FSR		;WX^[AhX
		movf	INDF,0
		movwf	d4
		goto	dpb5

dpb4	bcf		d4,7		;d4ɑΉ镶
dpb5	call	write_lcd4	;
		incf	poi,1
		decfsz	cn,1
		goto	dpb1
		return
;--------------------------------------------------
readb	bsf		STATUS,RP0	;oN1	;rb.2-7s input mode
		movlw	B'11111111'	;rb.0-7sin  !rb,#11111111b
		movwf	TRISB		;trisb
		bcf		STATUS,RP0	;oN0
		clrf	PORTB
		return

;---------
writb	bsf		STATUS,RP0	;oN1
		movlw	B'00001111'	; rb.4-rb.7sout  	
		movwf	TRISB		;trisb
		bcf		STATUS,RP0	;oN0
		return
;----------------


;----------------------------
FAdj1	call	readb		;input mode portb
FAdj2	btfss	PORTB,2		;Memory SW@ꂽH
		goto	FadMemo

		movf	PORTB,0	
		andlw	B'00000011'	
		movwf	new01
		
		call	wt255u	;255 usec҂.ݺނ̓,ݸޖh~

FAdj4	movf	new01,0		;if old01.0= new01, then goto FAdj2
		subwf	old01,0
		btfsc	STATUS,Z
		goto	FAdj2
		goto	FAdj5

FAdj5	btfss	old01,0		;if old01.0= HL,then next step, else goto FAdj2(FAdj_e)
		goto 	FAdj_e
		btfsc	new01,0
		goto 	FAdj_e
		goto	Fencd1

Fencd1	btfss	new01,1	;Rb1=LȂ vxo Zadd
		goto	Fj_dec	;Sub	DSPadj=DSPadj-1
		goto	Fj_add	;Add	DSPadj=DSPadj+1

Fj_dec	decf	DSPadj,1
		movlw	H'FF'
		subwf	DSPadj,0  ;W=DSPadj + (256-FF)
		movlw	H'0'
		btfss	STATUS,Z
		movf	DSPadj,0
		movwf	DSPadj		
		goto	FAdj9

Fj_add	incf	DSPadj,1
		movlw	H'8'
		subwf	DSPadj,0  ;W=DSPadj + (256-FF)		
		movlw	H'7'
		btfss	STATUS,Z
		movf	DSPadj,0
		movwf	DSPadj	
		goto	FAdj9

FAdj9	bcf		INTCON,7	;荞݋֎~

		movf	DSPadj,0	;XO 100MHz̕΍@\␳@@;@0=< DSPajd <=7
							;DSPajd l1@ɂ@80Hz(19.05MHz)420Hz(100MHz)̕␳
		xorlw	B'00110000'  ;㕔3A\	
		movwf	dec7
	;----	call	put chara
		call	writb				;/8step
		movlw	H'80'
		movwf	d4
		bcf		RS		;cursorʒu 
		call	write_lcd4			;/20step+40us
		;-------;;\				
		bsf		RS
		movf	dec7,0
		movwf	d4		
		call	write_lcd4
	;----
FAdj_e	movf	PORTB,0	
		andlw	B'00000011'	
		movwf	new01		;old01=new0
		movwf	old01
		goto	FAdj1

FadMemo	call	Fsave
		call	writb
		bsf		RS
		movlw	H'45'	;Chara'E'
		movwf	d4		
		call	write_lcd4
Fa_end	nop	
		goto	Fa_end	
		
;----------------
;		t[`
init_lcd
		bcf		RS			; RS='L'	
		movlw	B'00110000'	;mov	d8,#00110000b
		movwf	d8
		call	write_lcd8
		call	wait_20			; wait 4.1msȏ

		movlw	B'00110000'	;mov	d8,#00110000b
		movwf	d8
		call	write_lcd8
		call	wait_20			; wait 100usȏ

		movlw	B'00100000'		;mov	d8,#00100000b
		movwf	d8
		call	write_lcd8		; 0 0 0010 (4bit)
		
		movlw	B'00101000'	;mov	d4,#00101000b	; duty,font set9:Function set
		movwf	d4		
		call	write_lcd4

		movlw	B'00001000'		;mov	d4,#00001000b		; display off
		movwf	d4
		call	write_lcd4		

		movlw	B'00000001'		;mov	d4,#00000001b	; NAR}h:Clear Display
		movwf	d4
		call	write_lcd4
		call	wait_20		; NAI܂ő҂ Q0mbȏ
		
		movlw	B'00000110'		;mov	d4,#00000110b		; entry mode set
		movwf	d4
		call	write_lcd4

		movlw	B'00001110'	;mov	d4,#00001110b		; display on,cursor on
		movwf	d4
		call	write_lcd4
		return
;		Srbg[hptCg[`
write_lcd4
		movf	d4,0	;mov	d8,d4
		movwf	d8
		call	write_lcd8		;4ޯ
		
		movf	d4,0		;mov	d8,d4
		movwf	d8
		swapf	d8,1
		call	write_lcd8		;ʂSޯ
		return
;
;		Wrbg[hptCg[`
init_1	movlw	B'00110000'	;mov	d8,#00110000b
		movwf	d8
;
write_lcd8	
		clrf	cs
		rlf		d8,1		;;d8.7cs.0
		rrf		cs,1
		rlf		d8,1		;d8.6cs.1
		rrf		cs,1
		rlf		d8,1		;;d8.5cs.2
		rrf		cs,1		
		rlf		d8,1		 ;d8.4cs.3W
		rrf		cs,0
		andlw	B'11110000'
		movwf	PORTB		; Wqa|[g֏o
		bsf		E			; ds'H'
		nop
		bcf		E

		movlw	D'40'	;wait 40sec
		movwf	wait_cn
		call	wait_us
		bsf		E	 ;ǉ	
		return
;---------------------------------------------------------------------------------
;		I[_[̃EFCg
;
wait_255
		movlw	D'255'	;mov	wait_cn,#255
		movwf	wait_cn
		goto	wait_ms

wt15ms	movlw	D'15'	;mov	wait_cn,#15
		movwf	wait_cn
		goto	wait_ms

wt4ms	movlw	D'4'	;mov	wait_cn,#4
		movwf	wait_cn
		goto	wait_ms

wt1ms	movlw	D'1'	;mov	wait_cn,#4
		movwf	wait_cn
		goto	wait_ms

wt255u	movlw	D'255'	;mov	wait_cn,#255
		movwf	wait_cn
		goto	wait_us

wt5u	movlw	D'5'	;mov	wait_cn,#5
		movwf	wait_cn
		goto	wait_us

wait_20	movlw	D'20'		;mov	wait_cn,#20
		movwf	wait_cn
wait_ms  	
wait_ms0	
		movlw	D'0'	;mov	wait_cn2,#0
		movwf	wait_cn2
wait_ms1
		movlw	2	
		movwf	cp
wait_ms2
		nop
		decfsz	cp,1
		goto	wait_ms2		
		decfsz	wait_cn2,1
		goto	wait_ms1	;djnz	wait_cn2,wait_ms1

		decfsz	wait_cn,1
		goto	wait_ms0	;djnz	,
		return
;
;		ʂI[_[̃EFCg
;
wait_us		
wait_us0
		decfsz	wait_cn,1	;djnz	wait_cn,wait_us0
		goto	wait_us0
		return
;===============
AD98wake
ddsinit	movlw	B'00100001' ;䃏[h  reset=0bit 1 //Ref.AiOfoCX an-1070
		movwf	CtbU
		movlw	B'00000000'  ;䃏[h
		movwf	CtbL
		goto	dds1

AD98fin	movlw	B'11000000' ;䃏[h  reset=0bit 0 //ʑWX^0 MSB
		movwf	CtbU
		movlw	B'00000000'  ;䃏[h
		movwf	CtbL
		call	dsdata	;f[^@16bit 

		movlw	B'00100000' ;䃏[h  reset=0bit 0 //Zbg̏I
		movwf	CtbU
		movlw	B'00000000'  ;䃏[h
		movwf	CtbL
		call	dsdata	;f[^@16bit 
		return
		;------------
		;-------------
	;			;ޑoɂDDS set
			;FREQ0ɏ݁Ao͂ ;@about 800cycle //0.4msec
AD98set;	bcf		INTCON,7	;荞݋֎~ 
		bcf		Fselct	; FSelect Pin enabled, then PORTA,1=L for Freq0
		movlw	B'00100000' ;䃏[h  Freq0; D15, D14=0  D13(B28;14MSB+ 14LSB)=1 D11(Freq0)=0 
		movwf	CtbU
		movlw	B'00000000'  ;䃏[h
		movwf	CtbL
		clrf	Reg_Freq
		goto	dds1

AD98TX	bcf		INTCON,7	;荞݋֎~ 
		bsf		Fselct	; FSelect Pin enabled, then PORTA,1=H for Freq1
		movlw	B'00101010' ;䃏[h  Freq1; D15, D14=0  D13(B28;14MSB+ 14LSB)=1 D11(Freq0)=0 D9(PINSW)=1
		movwf	CtbU
		movlw	B'00000000'  ;䃏[h
		movwf	CtbL
		bsf		Reg_Freq,0	; if Reg_Freg=1, Freq Regist1,
		goto	dds1

AD98RX  bcf		INTCON,7	;荞݋֎~ 
		bcf		Fselct	;;AD9834 set for RX RIT
		movlw	B'00100010' ;䃏[h  Freq0; D15, D14=0  D13(B28;14MSB+ 14LSB)=1 D11(Freq0)=0 D9(PINSW)=1
		movwf	CtbU
		movlw	B'00000000'  ;䃏[h
		movwf	CtbL
		bcf		Reg_Freq,0	; if Reg_Freg=0, Freq Regist0,
		goto	dds1

dds1	nop
		;ݏ@CtbU(8bit)+CtbL(8bit)  00100000 00000000 ;Ref. to Table 11. AD9834 data
		;ݏ@LsbU(8bit)+LsbL(8bit)  01000000 00000000
		;ݏ@MsbU(8bit)+MsbL(8bit)  01111111 11111111  
		movf	Freq2,0	
		movwf	MsbU
		movf	Freq1,0
		movwf	MsbL

		movf	Freq0,0
		movwf	LsbU
		clrf	LsbL

		bcf		STATUS,C
		rrf		MsbU,1
		rrf		MsbL,1
		rrf		LsbU,1
		rrf		LsbL,1

		bcf		STATUS,C
		rrf		MsbU,1
		rrf		MsbL,1
		rrf		LsbU,1
		rrf		LsbL,1

		bcf		STATUS,C
		rrf		LsbU,1
		rrf		LsbL,1	

		bcf		STATUS,C
		rrf		LsbU,1
		rrf		LsbL,1	

		btfsc	Reg_Freq,0		;if Reg_Freg=0, Freq Regist0(ʏ), if Reg_Freg=1, Freq Regist1,
		goto	dds3
dds2	bsf		LsbU,6	;Regist Freq0 ݎw
		bsf		MsbU,6 	;Regist Freq0 ݎw
		goto	dds4

dds3	bsf		LsbU,7	;Regist Freq1 ݎw
		bsf		MsbU,7 	;Regist Freq1 ݎw

dds4	call	dsdata	;f[^@16bit +gf[^@LSB@16bit +gf[^@MSB@16bit
		bsf		INTCON,7	;荞݊Jn
		return
	;----------------------
dsdata	movlw   D'48'
        movwf   cs
		bsf     FSY 	; AD9834 Fsync
		bsf		AD34CK  ;AD9834 SCK;clock:H
		bcf		FSY 
dsd1	call	rotate	;12cy
		bcf     AD34CK			;clock:L
		bsf		AD34CK  ;AD9834 SCK;clock:H
		decfsz	cs,1
        goto    dsd1

		bsf 	FSY			;FSYNC:H ۰ފ
		return

rotate	bcf		STATUS,C	;12cycle	;ް̑o
		rlf     MsbL,1		
		rlf     MsbU,1		;14bit MSB
		rlf     LsbL,1		
		rlf     LsbU,1		;14bit LSB
		rlf     CtbL,1
		rlf		CtbU,1

		btfss	STATUS,C			;DatacixMSBj𑗏o
		bcf     DAT			;
		btfsc	STATUS,C			;
		bsf     DAT			;
		return
;-----------------------


;	---------------	end of lcd.asm
;    ---------------------------------------------------
load_dsp
		movlw	H'6'
		movwf	ADDR
		movlw	D'1'      
		movwf	scn

		movlw	DSPadj   ;LCD g\
		movwf	FSR
		goto	load_rt

load_1st
		movlw	H'0'
		movwf	ADDR
		movlw	D'1'      
		movwf	scn

		movlw	stROM   ;stROM, Freqo,Freq1,Freq2,Nband- 5address
		movwf	FSR
		goto	load_rt
;	;------------------------
;		;#00h   #01h    #02h    #03h	#04h	#05h	#06h	#07h
;		;stROM, Freq0,	Freq1,	Freq2,	Nband- 5Aaddress	
load_m	movlw	H'0'
		movwf	ADDR
		movlw	D'5'      
		movwf	scn

		movlw	stROM   ;stROM, Freqo,Freq1,Freq2,Nband- 5address  
		movwf	FSR
load_rt	bcf		STATUS,RP0	;Bank2/Select Bank of EEADR
		bsf		STATUS,RP1	;Bank2/
		
		movf	ADDR,0      	;EEPROM address 0&h
		movwf	EEADR		; Data Memory Address to read

		bsf		STATUS,RP0		;Bank3/	Select Bank of EECON1
		bcf		EECON1,EEPGD	; Select Bank of EECON1
		bsf		EECON1,RD		; EE Read

		bcf		STATUS,RP0		;Bank2/ Select Bank of EEDATA
		movf	EEDATA,0      
		movwf	INDF

		incf	ADDR,1
		incf	FSR,1
		decfsz	scn,1
		goto	load_rt

		bcf		STATUS,RP0	;Bank0
		bcf		STATUS,RP1
		return
;    ------------------------------------
Fsave	movlw	H'6'
		movwf	ADDR
		movf	DSPadj,0   ;LCD g\
		movwf	VALUE
		call	datawrite
		return
	;-----------
Memory	
sav_ini		;
		movlw	H'0'
		movwf	ADDR
		movlw	D'5'      
		movwf	scn

		movlw	stROM   ;stROM, Freqo,Freq1,Freq2,Nband- 5address;
		movwf	FSR
sav_i5	movf	INDF,W
		movwf	VALUE
		call	datawrite
		incf	ADDR,1
		incf	FSR,1
		decfsz	scn,1
		goto	sav_i5
		goto	ch27e
	;	;return
;   ----------------------------------------		
datawrite	
		bsf		STATUS,RP0	;Bank3
		bsf		STATUS,RP1	;Bank3/	Select Bank of EECON1

	;	bcf		EECON1,WR
dr1		btfsc	EECON1,WR	;Wait for write to complete
		goto	dr1

		bcf		STATUS,RP0	;Bank2/Select Bank of EEADR
		movf	ADDR,W
		movwf	EEADR		;Data Memory Address to write

		movf 	VALUE,W  	;
		movwf	EEDATA 		; Data Memory Value to write

		bsf		STATUS,RP0	;Bank3/	Select Bank of EECON1
		bcf		EECON1,EEPGD	;; Point to DATAmemory 	
		bsf		EECON1,WREN		;WRENޯ on; Enable writes

		bcf		INTCON,GIE 		; Disable INTs
	;-----
		movlw	H'55'
		movwf	EECON2
		movlw	H'aa'
		movwf	EECON2
		bsf		EECON1,WR 		; Set WR bit to begin write
	;-----
		bsf		INTCON,GIE 		; Enable INTs.
		bcf		EECON1,WREN 	; Disable writes

		call	wt15ms		; wait 15ms
		bcf		STATUS,RP0	;Bank0
		bcf		STATUS,RP1
		return
;***********************************************************************
;---------------------
;	8rbgoCiPOiϊ
;	val08rbgf[^uB val0<99
dc_rit	movlw	decrit1		;; i[ꏊl
		movwf	FSR
		incf	FSR,1
		call	devi			; ŉʕϊ 
		call	devi			;2JԂ
		return

devi	movlw	D'8'		;mov	cn,#8			; 8rbgԂ
		movwf	cn
		clrf	val_m
devi0		
		bcf		STATUS,C
		rlf		val0,1
		rlf		val_m,1
		
		movlw	B'11110110'
		addwf	val_m,0
		btfsc	STATUS,C
		movwf	val_m		;mov	val_m,w
		btfsc	STATUS,C
		incf	val0,1
		
		decfsz	cn,1		;djnz	cn,devide0
		goto	devi0

		decf	FSR,1
		movf	val_m,0		;mov	indirect,val_m		; ]
		xorlw	B'00110000'	;;set upper bit=3 for LCD display
		movwf	INDF
		return

;---------------------------------------------------------------------
;	24rbgoCiPOiϊ
;
;	val24rbgf[^uBi:val[2]:val[1]:va[0])
;
;	dcmainR[B
;
;	decɓi[B
;		(dec[2]:dec[3]:...:dec[8]:dec[9])
;		dec[2]ŏʌdec[9]ŉʌłB
;
;	ϊval͔j󂳂B
;
;	sample:
;		val	= 00:00:04:D2 h
;		dec	= 00:00:00:00:00:00:01:02:03:04
;                  dec(0):dec(1):(2):(3):(4):(5):(6):(7):(8):dec(9)
;						(1,234)
;
dcmain
		movlw	dec9		;;mov	fsr,#dec_top	; i[ꏊl
		movwf	FSR
		incf	FSR,1
		call	devide			; ŉʕϊ 
		call	devide			;10JԂ
	;	call	devide
	;	call	devide
		call	devide

		call	devide
dcm1	call	devide
		call	devide
		call	devide
		call	devide			; ŏʕϊ
		
zeroblank
		movlw	D'5'		;**.*MHz\̑2܂blank\
		movwf	cn			;Zero Blanku

		movlw	dec2	;movlw  dec0	;; dec[0]i[ꏊl
		movwf	FSR
zb1		movlw	B'00110000'
		subwf	INDF,0
		btfss	STATUS,Z		;if dec[]=00, then continue, else return
		goto	zb3
zb2			;if dec[]=00, then dec[]=0ehł́Ablank \ƂȂ
		movlw	H'20'	;Letter'_'
		movwf	INDF	;movwf	indirect

		incf	FSR,1
		decfsz	cn,1
		goto	zb1

zb3		movf	Nband,0
		xorlw	B'00110000'	;;set upper bit=3 for LCD display
		movwf	dec0
		return

;
;		POTu[`
;		POŏZ܂
;
devide		
		movlw	D'32'		;mov	cn,#32			; RQrbgԂ
		movwf	cn
		clrf	val_m
devide0		
		bcf		STATUS,C
		rlf		val0,1
		rlf		val1,1
		rlf		val2,1
		rlf		val3,1
		rlf		val_m,1
		
		movlw	B'11110110'
		addwf	val_m,0
		btfsc	STATUS,C
		movwf	val_m		;mov	val_m,w
		btfsc	STATUS,C
		incf	val0,1
		
		decfsz	cn,1		;djnz	cn,devide0
		goto	devide0

		decf	FSR,1
		movf	val_m,0		;mov	indirect,val_m		; ]
		xorlw	B'00110000'	;;set upper bit=3 for LCD display
		movwf	INDF
		return
;----------------------------------------end of 10iϊ	
;-----------------------
;	Z		(24bit)(24bit)|y(24bit)@
sub_xy
		movf	y0,0				;sub	x[0],y[0]
		subwf	x0,1
		movlw	1
		btfss	STATUS,C
		subwf	x1,1
		btfss	STATUS,C
		subwf	x2,1
	;	btfss	STATUS,C
	;	subwf	x3,1

		movf	y1,0				;sub	x[1],y[1];
		subwf	x1,1
		movlw	1
		btfss	STATUS,C
		subwf	x2,1
	;	btfss	STATUS,C
	;	subwf	x3,1

		movf	y2,0				;sub	x[2],y[2];
		subwf	x2,1		
								
	;	movlw	1
	;	btfss	STATUS,C
	;	subwf	x3,1
		
	;	movf	y3,0				;sub	x[3],y[3]
	;	subwf	x3,1								
		return
;--------------------------------------------------------------------
;------------------------------------
; 	Z	(24bit)(24bit){y(24bit)@
;
add_xy				
		movf	y0,0				;add	x[0],y[0]
		addwf	x0,1
		movlw	1
		btfsc	STATUS,C
		addwf	x1,1
		btfsc	STATUS,C
		addwf	x2,1
	;	btfsc	STATUS,C
	;	addwf	x3,1
		
		movf	y1,0				;add	x[1],y[1]
		addwf	x1,1
								
		movlw	1
		btfsc	STATUS,C
		addwf	x2,1
	;	btfsc	STATUS,C
	;	addwf	x3,1
		
		movf	y2,0				;add	x[2],y[2]	]
		addwf	x2,1
							
	;	movlw	1
	;	btfsc	STATUS,C
	;	addwf	x3,1

	;	movf	y3,0				;add	x[3],y[3]
	;	addwf	x3,1		
								
		return
;-----------------------------------------------------------------------
;	|Z		x[32bit]=val[24bit] * N[8bit]
;
;	nr 24rbgf[^uB
;		i:val[2]:val[1]:val[0]) 	vZߒ val_m g
;       N 8ޯްuB
;                 N ;  ő  #255łB
;
;	xɓi[B
;                ix[3]:x[2]:x[1]:x[0]) 
;       		
;	ϊ N ͔j󂳂ȂB
;
;
mult_vN	clrf		x3
		clrf		x2
		clrf		x1
		clrf		x0
		clrf		val_m			;ǉ1
			
		movlw 	D'8'
		movwf 	cn
mult0		
		btfss	N,0
		goto	mutpas

		movf	val0,0				;add	x[0],step[0]
		addwf	x0,1
		movlw	D'1'
		btfsc	STATUS,C
		addwf	x1,1
		btfsc	STATUS,C
		addwf	x2,1
		btfsc	STATUS,C
		addwf	x3,1

		movf	val1,0				;add	x[1],step[1]
		addwf	x1,1		
									
		movlw	D'1'
		btfsc	STATUS,C
		addwf	x2,1
		btfsc	STATUS,C
		addwf	x3,1

		movf	val2,0				;add	x[2],step[2]	
		addwf	x2,1		
									
mutpas	bcf		STATUS,C
		rlf		val0,1
		rlf		val1,1
		rlf		val2,1
		rlf		val_m,1		;ǉ1
		btfsc	STATUS,C
		bsf		val0,0

		bcf		STATUS,C
		rrf		N,1
		btfsc	STATUS,C
		bsf		N,7

		decfsz	cn,1			;	djnz	cn,mult0
		goto	mult0

		movlw	D'8'
		movwf	cn
multrot	bcf		STATUS,C
		rrf		val_m,1				;ǉ1
		rrf		val2,1
		rrf		val1,1
		rrf		val0,1
	;	btfsc	STATUS,C
	;	bsf		val3,7
		decfsz	cn,1			;djnz	cn,multrot
		goto 	multrot
		return
;---------------------------end of |Z
;-----------------------------------------------------
;	32rbgoCiZTu[`
;		val<32bit> = x<32bit> / y<16bit>; 
;
;	x 32 rbgf[^u܂B
;		ix[3]:x[2]:x[1]:x[0]) 
;       y 16ޯްu܂B
;              y[1]:y[0];  ő  H'FFFF'łB
;
;	val ɓi[܂B
;                ival[3]:val[2]:val[1]:val[0])  ]x[1][0]
;	vZ̉ߒ	Z		(32bit)(32bit)|y(32bit)gp
;       vZ̉ߒval[3]-val[0]Aval[0] ĝŒ`KvłB
;		
;
Div_xYY
		movf	y1,0		;y=y *256*256
		movwf	y3
		movf	y0,0
		movwf	y2
		clrf	y1
		clrf	y0
		movlw	D'17'			
		movwf	cn
		movlw	D'16'			
		movwf	cs
		clrf	val0
		clrf	val1
		clrf	val2
		clrf	val3

Dv1		movf	cs,1
		btfsc	STATUS,Z	;if y=0, can't divided then return
		return	
		btfsc	y3,7	;if y3.7 =0, then y rotate
		goto	Dv2
		bcf		STATUS,C
		rlf		y2,1
		rlf		y3,1
		incf	cn,1
		decfsz	cs,1
		goto 	Dv1		
				
Dv2		;;x>=y ? check
		movf	x3,0
		subwf	y3,0		; W=y3+ (256-x3)
		btfss	STATUS,C	; if y3<x3, then Dv3
		goto	Dv3
		btfss	STATUS,Z	; if y3>x3, then Dv4
		goto	Dv4

		movf	x2,0
		subwf	y2,0		; W=y2+ (256-x2)
		btfss	STATUS,C	; if y2<x2, then Dv3
		goto	Dv3
		btfss	STATUS,Z	; if y2>x2, then Dv4
		goto	Dv4

		movf	x1,0
		subwf	y1,0		; W=y1+ (256-x1)
		btfss	STATUS,C	; if y1<x1, then Dv3
		goto	Dv3
		btfss	STATUS,Z	; if y1>x1, then Dv4
		goto	Dv4

		movf	x0,0
		subwf	y0,0		; W=y0+ (256-x0)
		btfss	STATUS,C	; if y0<x0, then Dv3
		goto	Dv3
		btfss	STATUS,Z	; if y0>x0, then Dv4
		goto	Dv4
		goto	Dv3

Dv3		;x>=y@Ȃ̂ňZ
		call 	sub_xy	;(32bit)(32bit)|y(32bit)
		bsf		STATUS,C	
		goto	Dv5

Dv4		;x<y Ȃ̂ 
		bcf		STATUS,C	
Dv5		rlf		val0,1
		rlf		val1,1
		rlf		val2,1
		rlf		val3,1	
		decfsz	cn,1		
		goto	Dv6
		return
Dv6		bcf		STATUS,C
		rrf		y3,1	
		rrf		y2,1
		rrf		y1,1	
		rrf		y0,1
		goto	Dv2
	;=============================
      END                       ; directive 'end of program'
